////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*****************************************************************************
*
* FILE NAME:		userFunc.c
*
* DESCRIPTION:		foCXŗL(t[[NR[܂)
*
*
\*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <rt.h>
#include "edgeCode.h"

/*****************************************************************************
* FUNCTION:     CB_INIT
*
* DESCRIPTION:
*  hCo
\*****************************************************************************/
DWORD CB_INIT(EgFWdesc* desc, DWORD* errStatus)
{
	char* pApiName = NULL;			// API
	DWORD dwRes = 0;				// ߂l
	DWORD(*func_init)(char* szIFName, IFHANDLE* hIF, DWORD dwTimeout, DWORD* dwAPIStatus);	// ֐|C^
	Log$(ServiceRealName, EG_LOG_OPE, "CB_INIT Start... ");

	fnGetApiName(&pApiName);								//API擾

	// TODO: foCXŗL
	*((LPPROC*)&func_init) = desc->RSLHiInit;//֐|C^Rs[(OɂȂ`FbNĂ邽߂ł͂͂)
	dwRes = (*func_init)(pApiName, &desc->hIF, MyState.Timeout, errStatus);
	if (dwRes == CB_STS_FATALERR)
	{
		// s
		Log$(ServiceRealName, EG_LOG_ERR, "Init Failure. Status[%xH] API Status[%xH]", dwRes, *errStatus);
		MyState.Error = TRUE;
	}

	// `Ăꍇ̂ݓo^
	if (desc->RSLHiConnectChk != NULL)
		desc->cb_ConnectChk = mycb_ConnectChk;			// foCXڑԃ`FbN R[obNo^
	// `Ăꍇ̂ݓo^
	if (desc->RSLHiReConnect != NULL)
		desc->cb_ReConnect = mycb_ReConnect;			// foCXĐڑ R[obNo^


	// Cxg҂Xbhꍇ͈ȉ̃vCIeBgp
	egUserDesc.PriEveThread = (MyState.OutPriority < MyState.InPriority) ? MyState.OutPriority : MyState.InPriority;	// ق̃vCIeB擾
	desc->pDevDesc = &egUserDesc;					// foCXŗL`Zbg
	
	Log$(ServiceRealName, EG_LOG_OPE, "CB_INIT End. ");
	return CB_STS_OK;
}

/*****************************************************************************
* FUNCTION:     CB_OPEN
*
* DESCRIPTION:
*  ʐMI[vA|[OJn܂B
\*****************************************************************************/
DWORD CB_OPEN(EgFWdesc *desc, DWORD* errStatus)
{
	DWORD			dwRes = 0;
	DWORD(*func_open)(IFHANDLE hIF, RSIHANDLE* hRsi, DWORD dwTimeout, DWORD* dwAPIStatus);	// ֐|C^
	WORD			woEhStatus = 0;

	// I[vJn
	Log$(ServiceRealName, EG_LOG_OPE, "CB_OPEN Start... ");

	// TODO: ʐMI[v
	
	*((LPPROC*)&func_open) = desc->RSLHiOpen;//֐|C^Rs[(OɂȂ`FbNĂ邽߂ł͂͂)
	dwRes = (*func_open)(desc->hIF, &desc->hRsi, MyState.Timeout, errStatus);
	if (dwRes != 0)
	{
		// I[vs
		Log$(ServiceRealName, EG_LOG_ERR, "Open Failure. Status[%xH] API Status[%xH]", dwRes, *errStatus);
		MyState.Error = TRUE;
		return dwRes;
	}

	// I[v
	Log$(ServiceRealName, EG_LOG_OPE, "Open Success. Status[%xH] API Status[%xH]", dwRes, *errStatus);

	// ڑς݃tOON
	MyState.Connect = TRUE;

	// G[ȂƂ
	MyState.Error = FALSE;

	Log$(ServiceRealName, EG_LOG_OPE, "CB_OPEN End. ");

	return dwRes;
}

/*****************************************************************************
* FUNCTION:     CB_CLOSE
*
* DESCRIPTION:
*  ʐMN[Y܂B
\*****************************************************************************/
DWORD CB_CLOSE(EgFWdesc *desc, DWORD* errStatus)
{
	DWORD			dwRes = 0;
	DWORD(*func_close)(RSIHANDLE hRsi, DWORD* dwAPIStatus);	// ֐|C^

	Log$(ServiceRealName, EG_LOG_OPE, "CB_CLOSE Start... ");

	// ڑtOOFF
	MyState.Connect = FALSE;

	// TODO: ʐMN[YA\[X̉
	*((LPPROC*)&func_close) = desc->RSLHiClose;//֐|C^Rs[(OɂȂ`FbNĂ邽߂ł͂͂)
	dwRes = (*func_close)(desc->hRsi, errStatus);

	Log$(ServiceRealName, EG_LOG_OPE, "CB_CLOSE End. Status[%xH] API Status[%xH]", dwRes, *errStatus);
	return CB_STS_OK;
}

/*****************************************************************************
* FUNCTION		CB_READ
*
* DESCRIPTION:	foCX̓͒l擾
*  [TODO]FEdgeIO|[g`ɊÂfoCX̓͏ĂB
\*****************************************************************************/
DWORD CB_READ(EgFWdesc *desc, WORD woID, uint64_t address, void* pData, long readsize, long bufsize, EGIOPORT *egio)
{
	// TODOFfoCX̓͒l擾
	DWORD			dwRes = 0;
	DWORD			dwStatus = 0;		// API߂l
	DWORD(*func_read)(RSIHANDLE hRsi, WORD woID, DWORD address, DWORD readsize, BYTE *pData, DWORD buffersize, DWORD dwTimeout, DWORD* dwAPIStatus);	// ֐|C^

	// TODO: (G[)XbhŐVG[l̍XV
	*((LPPROC*)&func_read) = desc->RSLHiRead;//֐|C^Rs[(OɂȂ`FbNĂ邽߂ł͂͂)
	dwRes = (*func_read)(desc->hRsi, woID, egio->Offset, readsize, pData, bufsize, MyState.Timeout, &dwStatus);
	if (dwRes == 0)
		return CB_STS_OK;

	fnTagWriteInThreadLastErr(woID, dwStatus);
	return dwRes;
}

/*****************************************************************************
* FUNCTION:		CB_WRITE
*
* DESCRIPTION:	foCXւ̏o͏
*  [TODO]FEdgeIO|[g`ɊÂfoCXւ̏o͏ĂB
\*****************************************************************************/
DWORD CB_WRITE(EgFWdesc *desc, WORD woID, uint64_t address, void* pData, long writesize, EGIOPORT *egio)
{
	// TODOFfoCXւ̏o͏
	DWORD			dwRes = 0;
	DWORD			dwStatus = 0;		// API߂l
	DWORD(*func_write)(RSIHANDLE hRsi, WORD woID, DWORD address, DWORD writesize, BYTE *pData, DWORD dwTimeout, DWORD* dwAPIStatus);	// ֐|C^

	// TODO: (G[)XbhŐVG[l̍XV
	*((LPPROC*)&func_write) = MyFwDesc.RSLHiWrite;//֐|C^Rs[(OɂȂ`FbNĂ邽߂ł͂͂)
	dwRes = (*func_write)(desc->hRsi, woID, egio->Offset, writesize, pData, MyState.Timeout, &dwStatus);
	if (dwRes == 0)
		return CB_STS_OK; 
	
	fnTagWriteOutThreadLastErr(woID, dwStatus);
	return dwRes;
}

/*****************************************************************************
* FUNCTION:		mycb_ReConnect
*
* DESCRIPTION:	foCXĐڑ
*				R[obNo^ς݂̏ꍇAʐMQɃR[܂B
\*****************************************************************************/
DWORD mycb_ReConnect(EgFWdesc *desc, DWORD* errStatus)
{
	DWORD dwRet = CB_STS_OK;
	DWORD(*func_recon)(void*, DWORD, DWORD*);	// ֐|C^

	// foCXĐڑ 邩ۂ̃tOQ
	if (MyState.ExecuteReConnect == FALSE)//FALSȄꍇ͍ĐڏsȂ
		return CB_STS_OK;
	
	// TODOFfoCXڑԃ`FbN
	if (desc->RSLHiReConnect == NULL)//֐pӂĂȂꍇ͂̂܂ܕԂ
		return CB_STS_OK;

	*((LPPROC*)&func_recon) = desc->RSLHiReConnect;//֐|C^Rs[(OɂȂ`FbNĂ邽߂ł͂͂)
	dwRet = (*func_recon)((void*)desc, MyState.Timeout, errStatus);
	return dwRet;
}
/*****************************************************************************
* FUNCTION:		mycb_ConnectCheck
*
* DESCRIPTION:	foCXڑԃ`FbN
*				R[obNo^ς݂̏ꍇAwŃR[܂B
\*****************************************************************************/
BOOL mycb_ConnectChk(EgFWdesc *desc, DWORD* errStatus)
{
	BOOL bRet = FALSE;
	DWORD			dwRet = 0;
	DWORD			dwStatus = 0;		// API߂l
	DWORD			dwOpenStatus = 0;		// API߂l
	BOOL(*func_conchk)(void*, DWORD, DWORD*);	// ֐|C^
	// TODOFfoCXڑԃ`FbN
	if (desc->RSLHiConnectChk == NULL)//֐pӂĂȂꍇ͂̂܂ܕԂ
		return TRUE;

	*((LPPROC*)&func_conchk) = desc->RSLHiConnectChk;//֐|C^Rs[(OɂȂ`FbNĂ邽߂ł͂͂)
	bRet = (*func_conchk)((void*)desc, MyState.Timeout, &dwStatus);
	if (bRet == FALSE) //ĐڑĂ݂
	{
		MyState.dwConnectErrorCount++;
		if (MyState.dwConnectErrorCount > MyState.dwReConnectCount) //Đڑs񐔂ƃG[񐔂vꍇĐڑď
		{
			dwRet = mycb_ReConnect(desc, &dwOpenStatus);	//ĐڑĂяo
			if (CB_STS_OK == dwRet)			//OK̏ꍇēx`FbN̂Ԃ
			{
				//ēx`FbN
				bRet = (*func_conchk)((void*)desc, MyState.Timeout, &dwStatus);
			}
		}
	}
	else
		MyState.dwConnectErrorCount = 0;//
	
	*errStatus = dwStatus;	//G[R[hRs[
	return bRet;
}
/*****************************************************************************
* FUNCTION:		CB_WAIT
*
* DESCRIPTION:	Jn̑ҋ@
\*****************************************************************************/
DWORD CB_WAIT(EgFWdesc *desc, DWORD* errStatus)
{
	// TODOFfoCXւ̏o͏
	DWORD			dwRes = 0;
	DWORD			dwStatus = 0;		// API߂l
	DWORD(*func_wait)(RSIHANDLE hRsi, DWORD dwTimeout, DWORD* dwAPIStatus);	// ֐|C^

	// TODO: (G[)XbhŐVG[l̍XV
	*((LPPROC*)&func_wait) = MyFwDesc.RSLHiWait;//֐|C^Rs[(OɂȂ`FbNĂ邽߂ł͂͂)
	dwRes = (*func_wait)(desc->hRsi, MyState.WaitTimeout, &dwStatus);
	if (dwRes == 0)
		return CB_STS_OK;

	*errStatus = dwStatus;	//G[R[hRs[
	return dwRes;
}
/*****************************************************************************
* FUNCTION:		CB_MSGHandler
*
* DESCRIPTION:	bZ[Wnh[
\*****************************************************************************/
int32_t CB_MSGHandler(const char* sender, int32_t msgno, void *param)
{
	int32_t	result = 0;
	switch (msgno)
	{
	//
	// Cӂ̃bZ[Wǉ
	// case
	//
	default:						//LȊO͔
		break;
	}
	return result;
}




