//
//  RSI-CAN-E
//
//   RT-edge IIO(R) CAN Wrapper
//
//   Copyright (C) 2025 Micronet Co. All rights reserved.
//

#ifndef _eWrapCAN_H_
#define _eWrapCAN_H_

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

#ifdef  eWrapCAN_EXPORTS
#define eWrapCAN_API
#else
#define eWrapCAN_API __declspec(dllimport)
#endif

#include <egAPI.h>			// RT-edge system API
//
// define`
//

/* @memo ȉŌJĂ֐ׯ߂𓯖ō肽ׁAstaticݸ͕s(OՓ˂) */
#define LOWER_RSL_NAME  "eWrapECAT.rsl"
#define EHAPI_RSL_NAME  "ehapi.rsl"

#define __FILE_NAME__		(strrchr(__FILE__, '\\') ? strrchr(__FILE__, '\\')+1 : __FILE__)
#define Log$(pServiceName, pMode, MSG, ...)	fnLog(pServiceName, pMode, MSG",%s,%05d", __VA_ARGS__, __FILE_NAME__, __LINE__)
#define WARN(reason)	WarningMsg(__LINE__,(reason))

// R[obN֐̖߂l`
#define CB_STS_OK			EDGE_SUCCESS	// 
#define CB_STS_ERROR		0x00000001			// \G[
#define CB_STS_UNRECOVERY	0x00000010			// s\G[
#define CB_STS_FATALERR		0x00000100			// vIG[
#define EW_NOAPI			0xFFFFFFFF		// ֐

eWrapCAN_API DWORD HiInit(char* szIFName, IFHANDLE* hIF, DWORD dwTimeout, DWORD* dwAPIStatus);
eWrapCAN_API DWORD HiOpen(IFHANDLE hIF, RSIHANDLE* hRsi, DWORD dwTimeout, DWORD* dwAPIStatus);
eWrapCAN_API DWORD HiClose(RSIHANDLE hRsi, DWORD* dwAPIStatus);
eWrapCAN_API DWORD HiRead(RSIHANDLE hRsi, WORD woID, DWORD address, DWORD readsize, BYTE *pData, DWORD buffersize, DWORD dwTimeout, DWORD* dwAPIStatus);
eWrapCAN_API DWORD HiWrite(RSIHANDLE hRsi, WORD woID, DWORD address, DWORD writesize, BYTE *pData, DWORD dwTimeout, DWORD* dwAPIStatus);
eWrapCAN_API DWORD HiReConnect(void* ptr, DWORD dwTimeout, DWORD* dwAPIStatus);
eWrapCAN_API BOOL HiConnectChk(void* ptr, DWORD dwTimeout, DWORD* dwErrorStatus);
eWrapCAN_API DWORD HiWait(RSIHANDLE hRsi, DWORD dwTimeout, DWORD* dwAPIStatus);
#ifdef __cplusplus
}
#endif // __cplusplus

#endif
