//
//  RSI-CAN-E API
//
//   Copyright (C) 2025 Micronet Co. All rights reserved.
//

#include <rt.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <egAPI.h>	// RT-edge system API

/* @memo exportwͺ߲׵߼݂̕Őݒ肵Ă */
#include "eWrapCANIF.h"

//------------------------------------------------------------------------------
// Mݸޯ̧
//------------------------------------------------------------------------------
#include "../eWrapCAN/fifo.h"

//------------------------------------------------------------------------------
// @todo װڰp
//------------------------------------------------------------------------------
#define E$(PMSG, ...)

//----------------------------------------------------------------------------
// [Jϐ`
//----------------------------------------------------------------------------
struct {
	
	/* ̪ ڰތBRSL۰ޒ-1A0Aʏ^p0` */
	int slave_count;

	/* CANٓ󋵎擾p Entry */
	void *run;
	void *error;

	/* ڰޏ / ܰ */
	struct {
		/* Entry */
		void *fifo_in;		/* MFIFO  */
		void *fifo_out;		/* MFIFO */
		void *fifo_in_ovr;	/* MFIFO׸ */
		void *fifo_out_ovr;	/* MFIFO׸ */
		void *device_state;	/* CANʐM̓ */
	} *slave;
	
} work;

/*****************************************************************************
* FUNCTION:			get_tag_info
* DESCRIPTION:		CANʐM쐬ޏ擾
* 					@memo ҂ȂBĂяo_ő݂Ȃꍇ͎sB
\*****************************************************************************/
static bool get_tag_info(){
	
	/* ޱpܰر */
	uint32_t ret_d, val_buf;
	char prop_buf[EG_MAX_TAGNAME + 1];

	/* ލ쐬p APIďoEװ */
	#define TARGET_NAME
	#define EG_API(func, ...) \
		if ((ret_d = (func)(__VA_ARGS__)) != EDGE_SUCCESS) { \
			E$(#func "(%s) failed. Status[%08Xh]\n", TARGET_NAME, ret_d); \
			work.slave_count = -1/* ɖ߂ */; \
			return false; \
		} \

	/* work.slave_count(-1)̂ƂɌA(0)̨ */
	int c = InterlockedCompareExchange(&work.slave_count, 0, -1);
	if (c > 0) return true;		/*  */
	if (c == 0) return false;	/* (ɒNn߂Ă) */

	/* ڰތ擾(ޱ) */
	#undef TARGET_NAME
	#define TARGET_NAME	(CAN_TAG_NAME_BASE CAN_SLAVE_COUNT_TAG_NAME)
	EG_API(EgTagRead, CAN_TAG_NAME_BASE CAN_SLAVE_COUNT_TAG_NAME, &val_buf, sizeof(val_buf));
	c = val_buf;

	/* ڰފǗر쐬 */
	if (work.slave) free(work.slave);
	if ((work.slave = malloc(sizeof(*work.slave) * c)) == NULL) {
		E$("malloc failed. Status[%08Xh]\n", ret_d);
		work.slave_count = -1/* ɖ߂ */;
		return false;
	}

	#undef TARGET_NAME
	#define TARGET_NAME	(CAN_TAG_NAME_BASE "Run")
	EG_API(EgTagGetProperty, CAN_TAG_NAME_BASE "Run", "Entry", &work.run, sizeof(work.run));
	#undef TARGET_NAME
	#define TARGET_NAME	(CAN_TAG_NAME_BASE "Error")
	EG_API(EgTagGetProperty, CAN_TAG_NAME_BASE "Error", "Entry", &work.error, sizeof(work.error));

	/* FIFOpނ̴؂擾(APIďo̓xɖOȂ̂) */
	for (int i = 0; i < c; i++) {
		#undef TARGET_NAME
		#define TARGET_NAME	(prop_buf)
		sprintf(prop_buf, CAN_TAG_NAME_BASE "%02d" CAN_TX_FIFO_TAG_NAME, i);
		EG_API(EgTagGetProperty, prop_buf, "Entry", &work.slave[i].fifo_out, sizeof(work.slave[i].fifo_out));
		sprintf(prop_buf, CAN_TAG_NAME_BASE "%02d" CAN_RX_FIFO_TAG_NAME, i);
		EG_API(EgTagGetProperty, prop_buf, "Entry", &work.slave[i].fifo_in, sizeof(work.slave[i].fifo_in));
		sprintf(prop_buf, CAN_TAG_NAME_BASE "%02d" CAN_TX_FIFO_OVR_TAG_NAME, i);
		EG_API(EgTagGetProperty, prop_buf, "Entry", &work.slave[i].fifo_out_ovr, sizeof(work.slave[i].fifo_out_ovr));
		sprintf(prop_buf, CAN_TAG_NAME_BASE "%02d" CAN_RX_FIFO_OVR_TAG_NAME, i);
		EG_API(EgTagGetProperty, prop_buf, "Entry", &work.slave[i].fifo_in_ovr, sizeof(work.slave[i].fifo_in_ovr));
		sprintf(prop_buf, CAN_TAG_NAME_BASE "%02d" CAN_SLAVE_DEV_STATE_TAG_NAME, i);
		EG_API(EgTagGetProperty, prop_buf, "Entry", &work.slave[i].device_state, sizeof(work.slave[i].device_state));
	}
	
	/*  */
	work.slave_count = c;
	return true;

	#undef TARGET_NAME
	#undef EG_API
}

/*****************************************************************************
* FUNCTION:			CAN_ManualStart
* DESCRIPTION:		ײނ̓Jn(AutoRun𖳌ĂꍇɎgp)
*					@memo RunԂ֑Jڂ܂łɂ׸ނ邪A{API͂҂ȂB
*					      ʓrCAN_GetDriverState()is_runningmF邱ƂŁA
*					      JڏԂmF邱ƂłB
* ߂l:			0B̏ꍇُ͈(CANʐMs݂Ȃ)
\*****************************************************************************/
int CAN_ManualStart(void) {

	int ret_d;
	RTCDHANDLE h;
	
	/* APIďoEװ */
	#define EG_API(func, ...) \
		if ((ret_d = (func)(__VA_ARGS__)) != EDGE_SUCCESS) { \
			E$(#func "() failed. Status[%08Xh]\n", ret_d); \
			return ret_d; \
		} \
	
	EG_API(EgMailboxOpenSC, "ECAT", RTCD_WRITE, &h);
	EG_API(EgMailboxSend, &h, "ECAT"/* K */, EM_SERVICE_RUN, NULL, 0);
	EG_API(EgMailboxClose, &h);

	return ret_d;

	#undef TARGET_NAME
	#undef EG_API
}

/*****************************************************************************
* FUNCTION:			CAN_GetDriverState
* DESCRIPTION:		݂ײޓ󋵂擾
* :				o͐BNULLnڂ͏o͂Ȃ
* ߂l:			0B̏ꍇُ͈(CANʐMs݂Ȃ)
\*****************************************************************************/
int CAN_GetDriverState(bool *is_running, bool *error, unsigned int *instance_count) {

	int ret = 0;

	/* ޱ */
	if (!get_tag_info()) return -1/* ȂBCANʐMs݂Ƃ݂Ȃ */;

	if (is_running) ret |= EgTagReadByEntry(work.run, is_running, sizeof(*is_running));
	if (error)      ret |= EgTagReadByEntry(work.error, error, sizeof(*error));
	if (instance_count) *instance_count = work.slave_count;

	return ret;
}

/*****************************************************************************
* FUNCTION:			CAN_Read
* DESCRIPTION:		Mޯ̧ڰт1擾
* :				o͐BNULLnڂ͏o͂Ȃ
* 					SĂNULLnꍇAMڰт̎擾ʒui߂Ȃ(M߰ݸޗp)
* 					Aext͊g̫ϯĎw(trueID29bitΉ̫ϯĂƂ)B
* ߂l:			ĂяoJn_ł̎Mޯ̧̎c茏ԂB̏ꍇُ͈(ݽݽs݂Ȃ)
\*****************************************************************************/
int CAN_Read(unsigned int instance, uint32_t *can_id, bool *ext, bool *rtr, int *length, uint8_t *data)
{
	int ret = 0;
	uint16_t remain;
	
	/* APIװݸ */
	#define CHK_ERROR_PROC(do_proc) \
		if ((do_proc) != EDGE_SUCCESS) { \
			E$("Cannot access CAN Rx Frame FIFO (%d). Status[%08Xh]\n", i, ret_d); \
			return -3; \
		}

	/* ޱ */
	if (!get_tag_info()) return -1/* ȂBCANʐMs݂Ƃ݂Ȃ */;
	
	if ((int)instance < 0 || (int)instance >= work.slave_count) return -2/* ݽݽs */;
	
	CHK_ERROR_PROC(ret = EgTagGetRemainFIFOByEntry(work.slave[instance].fifo_in, &remain));
	if (!remain) return 0/* Ȃ */;
	
	/* 1擾 */
	{
		struct CAN_FRAME_FIFO_DATA_EXT fifo_data;;
		int write_count = 0;
		
		/* @memo FIFOڰѲҰނ́AڰގʂɊւ炸 EL6751 gID(29bit)ΉI/F̫ϯĂƂȂ */
		CHK_ERROR_PROC(ret = EgTagReadByEntry(work.slave[instance].fifo_in, &fifo_data, sizeof(fifo_data)));

		if (can_id){ write_count++; *can_id = fifo_data.head.id;     }
		if (ext)   { write_count++; *ext    = fifo_data.head.is_ext; }
		if (rtr)   { write_count++; *rtr    = fifo_data.head.rtr;    }
		if (length){ write_count++; *length = fifo_data.length;      }
		if (data)  { write_count++; memcpy(data, fifo_data.data, sizeof(fifo_data.data)); }
		
		/* FIFỎ */
		/* 擾ꍇrpi߂ */
		if (write_count) ret = EgTagDequeueFIFOByEntry(work.slave[instance].fifo_in, NULL, 0, NULL);
		if (ret != EDGE_FIFO_OVERRUN && ret != EDGE_FIFO_UNDERRUN) CHK_ERROR_PROC(ret);
		
	}
	
	/* DequeueOFIFOcԂ */
	return remain;

	#undef CHK_ERROR_PROC
}

/*****************************************************************************
* FUNCTION:			CAN_Write
* DESCRIPTION:		wݽݽɁAw肵CANڰт𑗐M
* :				Mް
* 					Aext͊g̫ϯĎw(trueID29bitƂ݂Ȃ)BgΉ̽ڰސݒɂȂĂꍇ͖
* ߂l:			s̑Mޯ̧̎c茏ԂB̏ꍇُ͈(ݽݽs݂Ȃ)
\*****************************************************************************/
int CAN_Write(unsigned int instance, uint32_t can_id, bool ext, bool rtr, int length, uint8_t *data)
{
	int ret = 0;
	uint16_t remain;

	/* APIװݸ */
	#define CHK_ERROR_PROC(do_proc) \
		if ((do_proc) != EDGE_SUCCESS) { \
			E$("Cannot access CAN Rx Frame FIFO (%d). Status[%08Xh]\n", i, ret_d); \
			return -3; \
		}

	/* ޱ */
	if (!get_tag_info()) return -1/* ȂBCANʐMs݂Ƃ݂Ȃ */;

	if ((int)instance < 0 || (int)instance >= work.slave_count) return -2/* ݽݽs */;
	
	/*  */
	if (length < 0 || length > 8) return -4;
	if (rtr && length != 0) return -5;

	/* 1 */
	{
		struct CAN_FRAME_FIFO_DATA_EXT fifo_data;

		/* @memo FIFOڰѲҰނ́AڰގʂɊւ炸 EL6751 gID(29bit)ΉI/F̫ϯĂƂȂ */
		fifo_data.head.id     = can_id;
		fifo_data.head.is_ext = ext;
		fifo_data.head.rtr    = rtr;
		fifo_data.length      = length;
		memcpy(fifo_data.data, data, sizeof(fifo_data.data));
		
		/* FIFỎ(wpi߂) */
		ret = EgTagEnqueueFIFOByEntry(work.slave[instance].fifo_out, &fifo_data, sizeof(fifo_data), &remain);
		if (ret != EDGE_FIFO_OVERRUN && ret != EDGE_FIFO_UNDERRUN) CHK_ERROR_PROC(ret);
	}

	/* FIFOcԂ */
	return remain;

	#undef CHK_ERROR_PROC
}

/*****************************************************************************
* FUNCTION:			CAN_GetDeviceState
* DESCRIPTION:		wݽݽDeviceState擾
* :				o͐BNULLnꍇ͏o͂Ȃ
* ߂l:			0(NULLꍇ0)B̏ꍇُ͈(ݽݽs݂Ȃ)
\*****************************************************************************/
int CAN_GetDeviceState(unsigned int instance, struct CAN_SLAVE_DEVICE_STATE *device_state) {

	/* ޱ */
	if (!get_tag_info()) return -1/* ȂBCANʐMs݂Ƃ݂Ȃ */;

	if ((int)instance < 0 || (int)instance >= work.slave_count) return -2/* ݽݽs */;
	if (device_state == NULL) return 0;

	/* @memo ʒm̫ϯĂͽڰގʂɊւ炸EL6751(ڶ޼ϯݸ)̫ϯĂƂ */
	/*       قȂ̫ϯĂ̽ڰނɑΉꍇ́AEL6751̗lɕϊĒʒm\B */
	return EgTagReadByEntry(work.slave[instance].device_state, device_state, sizeof(*device_state));
}

/*****************************************************************************
* FUNCTION:			CAN_GetOverrunState
* DESCRIPTION:		wݽݽ̑Mޯ̧ݔ󋵂擾
* :				o͐BNULLnꍇ͏o͂Ȃ
* ߂l:			0(NULLꍇ0)B̏ꍇُ͈(ݽݽs݂Ȃ)
\*****************************************************************************/
int CAN_GetOverrunState(unsigned int instance, bool *tx_overrun, bool *rx_overrun) {

	int ret = 0;

	/* ޱ */
	if (!get_tag_info()) return -1/* ȂBCANʐMs݂Ƃ݂Ȃ */;

	if ((int)instance < 0 || (int)instance >= work.slave_count) return -2/* ݽݽs */;

	if (tx_overrun) ret |= EgTagReadByEntry(work.slave[instance].fifo_out_ovr, tx_overrun, sizeof(*tx_overrun));
	if (rx_overrun) ret |= EgTagReadByEntry(work.slave[instance].fifo_in_ovr, rx_overrun, sizeof(*rx_overrun));

	return ret;
}

/*****************************************************************************
* FUNCTION:     RslMain
*
* DESCRIPTION:
*  RSL Main֐
\*****************************************************************************/
BOOLEAN __stdcall RslMain( RTHANDLE hModule,
						DWORD  ul_reason_for_call,  
						LPVOID lpReserved
						)
{
	switch (ul_reason_for_call) {
		case RSL_PROCESS_ATTACH:
			/* ۾ŗLܰر */
			work.slave_count = -1;
			work.slave = NULL;
			break;
		case RSL_THREAD_ATTACH:
			break;
		case RSL_THREAD_DETACH:
			break;
		case RSL_PROCESS_DETACH:
			break;
	}

	return TRUE;
}
