//
//  RSI-CAN-E API
//
//   Copyright (C) 2025 Micronet Co. All rights reserved.
//
//	{̧ق̎gpɂ́Aȉ̧ͯقKvłB
//	 <stdint.h>
//	 <stdbool.h>
//	
#ifndef _eWrapCANIF_H_
#define _eWrapCANIF_H_

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

#ifdef  eWrapCANIF_EXPORTS
#define eWrapCANIF_API
#else
#define eWrapCANIF_API __declspec(dllimport)
#endif

//------------------------------------------------------------------------------
// \̒`
//------------------------------------------------------------------------------
/* DeviceStateر */
#pragma pack(push, 1)
struct CAN_SLAVE_DEVICE_STATE {
	uint8_t node_state;					/* Bus node diagnostics: Node State (Box-State) */
	uint8_t error;						/* EL6751 diagnostics: Error */
	uint16_t can_state;					/* EL6751 diagnostics: CANState */
	uint8_t rx_error_count;				/* EL6751 diagnostics: RxErrorCounter */
	uint8_t tx_error_count;				/* EL6751 diagnostics: TxErrorCounter */
	unsigned char diag_flag : 1;		/* EL6751 diagnostics: DiagFlag */
	unsigned char node_diag_flag : 1;	/* Bus node diagnostics: DiagFlag */
	unsigned char padding1 : 6;			/* gp */
};
#pragma pack(pop)

/*****************************************************************************
* FUNCTION:			CAN_ManualStart
* DESCRIPTION:		ײނ̓Jn(AutoRun𖳌ĂꍇɎgp)
*					@memo RunԂ֑Jڂ܂łɂ׸ނ邪A{API͂҂ȂB
*					      ʓrCAN_GetDriverState()is_runningmF邱ƂŁA
*					      JڏԂmF邱ƂłB
* ߂l:			0B̏ꍇُ͈(CANʐMs݂Ȃ)
\*****************************************************************************/
eWrapCANIF_API int CAN_ManualStart(void);

/*****************************************************************************
* FUNCTION:			CAN_GetDriverState
* DESCRIPTION:		݂ײޓ󋵂擾
* :				o͐BNULLnڂ͏o͂Ȃ
* ߂l:			0B̏ꍇُ͈(CANʐMs݂Ȃ)
\*****************************************************************************/
eWrapCANIF_API int CAN_GetDriverState(bool *is_running, bool *error, unsigned int *instance_count);

/*****************************************************************************
* FUNCTION:			CAN_Read
* DESCRIPTION:		Mޯ̧ڰт1擾
* :				o͐BNULLnڂ͏o͂Ȃ
* 					SĂNULLnꍇAMڰт̎擾ʒui߂Ȃ(M߰ݸޗp)
* 					Aext͊g̫ϯĎw(trueID29bitΉ̫ϯĂƂ)B
* ߂l:			ĂяoJn_ł̎Mޯ̧̎c茏ԂB̏ꍇُ͈(ݽݽs݂Ȃ)
\*****************************************************************************/
eWrapCANIF_API int CAN_Read(unsigned int instance, uint32_t *can_id, bool *ext, bool *rtr, int *length, uint8_t *data);

/*****************************************************************************
* FUNCTION:			CAN_Write
* DESCRIPTION:		wݽݽɁAw肵CANڰт𑗐M
* :				Mް
* 					Aext͊g̫ϯĎw(trueID29bitƂ݂Ȃ)BgΉ̽ڰސݒɂȂĂꍇ͖
* ߂l:			s̑Mޯ̧̎c茏ԂB̏ꍇُ͈(ݽݽs݂Ȃ)
\*****************************************************************************/
eWrapCANIF_API int CAN_Write(unsigned int instance, uint32_t can_id, bool ext, bool rtr, int length, uint8_t *data);

/*****************************************************************************
* FUNCTION:			CAN_GetDeviceState
* DESCRIPTION:		wݽݽDeviceState擾
* :				o͐BNULLnꍇ͏o͂Ȃ
* ߂l:			0(NULLꍇ0)B̏ꍇُ͈(ݽݽs݂Ȃ)
\*****************************************************************************/
eWrapCANIF_API int CAN_GetDeviceState(unsigned int instance, struct CAN_SLAVE_DEVICE_STATE *device_state);

/*****************************************************************************
* FUNCTION:			CAN_GetOverrunState
* DESCRIPTION:		wݽݽ̑Mޯ̧ݔ󋵂擾
* :				o͐BNULLnꍇ͏o͂Ȃ
* ߂l:			0(NULLꍇ0)B̏ꍇُ͈(ݽݽs݂Ȃ)
\*****************************************************************************/
eWrapCANIF_API int CAN_GetOverrunState(unsigned int instance, bool *tx_overrun, bool *rx_overrun);


//------------------------------------------------------------------------------
// CAN APIgpȂޱ̂߂̍\̒`
//------------------------------------------------------------------------------
/* CANڰްҰ(29bit IDΉ) */
#pragma pack(push, 1)
struct CAN_FRAME_FIFO_DATA_EXT {

	uint16_t length;				/* BLl = 0`8 */
	struct {
		unsigned int id : 29;		/* ID */
		unsigned int : 1;			/* gp */
		unsigned int rtr : 1;		/* 1RTRڰсA0Œʏڰ */
		unsigned int is_ext : 1;	/* 129bit IDA011bit ID */
	} head;

	uint8_t data[8];				/* ް{ */
};
#pragma pack(pop)


#ifdef __cplusplus
}
#endif // __cplusplus

#endif
