//
//  RT-edge IIO(R) ECAT Wrapper
//
//   RSL development header
//
//   Copyright (c)Micronet Co. 2022
//
#ifndef _eWrapECAT_H_
#define _eWrapECAT_H_

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

#ifdef  eWrapECAT_EXPORTS
#define eWrapECAT_API
#else
#define eWrapECAT_API __declspec(dllimport)
#endif

#include <egAPI.h>			// RT-edge system API
//
// define`
//

#define HIAPI_NO_INIT	17330	//nCxAPI INIT 
#define HIAPI_NO_OPEN	17331	//nCxAPI OPEN 
#define HIAPI_NO_CLOSE	17332	//nCxAPI CLOSE 
#define HIAPI_NO_READ	17333	//nCxAPI READ 
#define HIAPI_NO_WRITE	17334	//nCxAPI WRITE 

#define HIAPI_RSL_NAME	"hiecat.rsl"
#define EHAPI_RSL_NAME  "ehapi.rsl"

#define __FILE_NAME__		(strrchr(__FILE__, '\\') ? strrchr(__FILE__, '\\')+1 : __FILE__)
#define Log$(pServiceName, pMode, MSG, ...)	fnLog(pServiceName, pMode, MSG",%s,%05d", __VA_ARGS__, __FILE_NAME__, __LINE__)
#define WARN(reason)	WarningMsg(__LINE__,(reason))

// R[obN֐̖߂l`
#define CB_STS_OK			EDGE_SUCCESS	// 
#define CB_STS_ERROR		0x00000001			// \G[
#define CB_STS_UNRECOVERY	0x00000010			// s\G[
#define CB_STS_FATALERR		0x00000100			// vIG[
#define EW_NOAPI			0xFFFFFFFF		// ֐

#define	CONNECTERR_ECAT_SNDRCVERR 0xFFFF0002 //t[M̃G[ 
#define	CONNECTERR_ECAT_PARSEERR 0xFFFF0004	//Mt[̃G[
#define	CONNECTERR_ECAT_LINKDOWN 0xFFFF0008	//NICA_v^ƃX[uԂ̐ڑ_E
#define	CONNECTERR_ECAT_WRONGCONFIG 0xFFFF0010	//RtBO\ُ
#define	CONNECTERR_ECAT_S2STIMEOUT 0xFFFF0020	//X[uToX[uʐMŃ^CAEg
#define	CONNECTERR_ECAT_DEFAULT_DATA 0xFFFF0040	//pPbgM/MG[߁AftHgf[^gpꂽ
#define	CONNECTERR_ECAT_WATCHDOG 0xFFFF0080	//EHb`hbO^CAEg

eWrapECAT_API DWORD HiInit(char* szIFName, IFHANDLE* hIF, DWORD dwTimeout, DWORD* dwAPIStatus);
eWrapECAT_API DWORD HiOpen(IFHANDLE hIF, RSIHANDLE* hRsi, DWORD dwTimeout, DWORD* dwAPIStatus);
eWrapECAT_API DWORD HiClose(RSIHANDLE hRsi, DWORD* dwAPIStatus);
eWrapECAT_API DWORD HiRead(RSIHANDLE hRsi, WORD woID, DWORD address, DWORD readsize, BYTE *pData, DWORD buffersize, DWORD dwTimeout, DWORD* dwAPIStatus);
eWrapECAT_API DWORD HiWrite(RSIHANDLE hRsi, WORD woID, DWORD address, DWORD writesize, BYTE *pData, DWORD dwTimeout, DWORD* dwAPIStatus);
eWrapECAT_API DWORD HiReConnect(void* ptr, DWORD dwTimeout, DWORD* dwAPIStatus);
eWrapECAT_API BOOL HiConnectChk(void* ptr, DWORD dwTimeout, DWORD* dwErrorStatus);
eWrapECAT_API DWORD HiWait(RSIHANDLE hRsi, DWORD dwTimeout, DWORD* dwAPIStatus);
#ifdef __cplusplus
}
#endif // __cplusplus

#endif
